Commit | Line | Data |
---|---|---|
e1970ce4 JH |
1 | # Run tests |
2 | # | |
3 | # Copyright (c) 2005 Junio C Hamano | |
4 | # | |
d6928ebd | 5 | |
b2b0026e | 6 | -include ../config.mak.autogen |
c14417c4 JK |
7 | -include ../config.mak |
8 | ||
dd6fc7ca | 9 | #GIT_TEST_OPTS = --verbose --debug |
edde7a8b | 10 | SHELL_PATH ?= $(SHELL) |
3f824e91 | 11 | TEST_SHELL_PATH ?= $(SHELL_PATH) |
4678a5cd | 12 | PERL_PATH ?= /usr/bin/perl |
455a7f32 | 13 | TAR ?= $(TAR) |
4cb08df5 | 14 | RM ?= rm -f |
28d836c8 MG |
15 | PROVE ?= prove |
16 | DEFAULT_TEST_TARGET ?= test | |
00f6991d | 17 | TEST_LINT ?= test-lint |
e1970ce4 | 18 | |
54bb9015 | 19 | ifdef TEST_OUTPUT_DIRECTORY |
b3e0c4ed | 20 | TEST_RESULTS_DIRECTORY = $(TEST_OUTPUT_DIRECTORY)/test-results |
80339445 | 21 | CHAINLINTTMP = $(TEST_OUTPUT_DIRECTORY)/chainlinttmp |
54bb9015 JK |
22 | else |
23 | TEST_RESULTS_DIRECTORY = test-results | |
80339445 | 24 | CHAINLINTTMP = chainlinttmp |
54bb9015 JK |
25 | endif |
26 | ||
4769948a | 27 | # Shell quote; |
39c015c5 | 28 | SHELL_PATH_SQ = $(subst ','\'',$(SHELL_PATH)) |
3f824e91 | 29 | TEST_SHELL_PATH_SQ = $(subst ','\'',$(TEST_SHELL_PATH)) |
c7ce70ac | 30 | PERL_PATH_SQ = $(subst ','\'',$(PERL_PATH)) |
54bb9015 | 31 | TEST_RESULTS_DIRECTORY_SQ = $(subst ','\'',$(TEST_RESULTS_DIRECTORY)) |
80339445 | 32 | CHAINLINTTMP_SQ = $(subst ','\'',$(CHAINLINTTMP)) |
4769948a | 33 | |
aae5239b | 34 | T = $(sort $(wildcard t[0-9][0-9][0-9][0-9]-*.sh)) |
aae5239b | 35 | TGITWEB = $(sort $(wildcard t95[0-9][0-9]-*.sh)) |
cd78cea2 | 36 | THELPERS = $(sort $(filter-out $(T),$(wildcard *.sh))) |
80339445 ES |
37 | CHAINLINTTESTS = $(sort $(patsubst chainlint/%.test,%,$(wildcard chainlint/*.test))) |
38 | CHAINLINT = sed -f chainlint.sed | |
e1970ce4 | 39 | |
28d836c8 MG |
40 | all: $(DEFAULT_TEST_TARGET) |
41 | ||
80339445 | 42 | test: pre-clean check-chainlint $(TEST_LINT) |
e3df89a4 | 43 | $(MAKE) aggregate-results-and-cleanup |
23fc63bf | 44 | |
93a04bb1 JS |
45 | failed: |
46 | @failed=$$(cd '$(TEST_RESULTS_DIRECTORY_SQ)' && \ | |
47 | grep -l '^failed [1-9]' *.counts | \ | |
48 | sed -n 's/\.counts$$/.sh/p') && \ | |
49 | test -z "$$failed" || $(MAKE) $$failed | |
50 | ||
80339445 | 51 | prove: pre-clean check-chainlint $(TEST_LINT) |
3f824e91 | 52 | @echo "*** prove ***"; $(PROVE) --exec '$(TEST_SHELL_PATH_SQ)' $(GIT_PROVE_OPTS) $(T) :: $(GIT_TEST_OPTS) |
60f26f63 | 53 | $(MAKE) clean-except-prove-cache |
28d836c8 | 54 | |
23fc63bf | 55 | $(T): |
3f824e91 | 56 | @echo "*** $@ ***"; '$(TEST_SHELL_PATH_SQ)' $@ $(GIT_TEST_OPTS) |
e1970ce4 | 57 | |
f8d5ffc2 | 58 | pre-clean: |
54bb9015 | 59 | $(RM) -r '$(TEST_RESULTS_DIRECTORY_SQ)' |
f8d5ffc2 | 60 | |
80339445 | 61 | clean-except-prove-cache: clean-chainlint |
54bb9015 | 62 | $(RM) -r 'trash directory'.* '$(TEST_RESULTS_DIRECTORY_SQ)' |
34b383e7 | 63 | $(RM) -r valgrind/bin |
60f26f63 MH |
64 | |
65 | clean: clean-except-prove-cache | |
9a3028b9 | 66 | $(RM) .prove |
23fc63bf | 67 | |
80339445 ES |
68 | clean-chainlint: |
69 | $(RM) -r '$(CHAINLINTTMP_SQ)' | |
70 | ||
71 | check-chainlint: | |
72 | @mkdir -p '$(CHAINLINTTMP_SQ)' && \ | |
73 | err=0 && \ | |
74 | for i in $(CHAINLINTTESTS); do \ | |
75 | $(CHAINLINT) <chainlint/$$i.test | \ | |
76 | sed -e '/^# LINT: /d' >'$(CHAINLINTTMP_SQ)'/$$i.actual && \ | |
77 | diff -u chainlint/$$i.expect '$(CHAINLINTTMP_SQ)'/$$i.actual || err=1; \ | |
78 | done && exit $$err | |
79 | ||
c2cafd39 JS |
80 | test-lint: test-lint-duplicates test-lint-executable test-lint-shell-syntax \ |
81 | test-lint-filenames | |
d38732c2 JK |
82 | |
83 | test-lint-duplicates: | |
84 | @dups=`echo $(T) | tr ' ' '\n' | sed 's/-.*//' | sort | uniq -d` && \ | |
85 | test -z "$$dups" || { \ | |
86 | echo >&2 "duplicate test numbers:" $$dups; exit 1; } | |
87 | ||
88 | test-lint-executable: | |
89 | @bad=`for i in $(T); do test -x "$$i" || echo $$i; done` && \ | |
90 | test -z "$$bad" || { \ | |
91 | echo >&2 "non-executable tests:" $$bad; exit 1; } | |
92 | ||
c7ce70ac | 93 | test-lint-shell-syntax: |
cd78cea2 | 94 | @'$(PERL_PATH_SQ)' check-non-portable-shell.pl $(T) $(THELPERS) |
c7ce70ac | 95 | |
c2cafd39 JS |
96 | test-lint-filenames: |
97 | @# We do *not* pass a glob to ls-files but use grep instead, to catch | |
98 | @# non-ASCII characters (which are quoted within double-quotes) | |
99 | @bad="$$(git -c core.quotepath=true ls-files 2>/dev/null | \ | |
100 | grep '["*:<>?\\|]')"; \ | |
101 | test -z "$$bad" || { \ | |
102 | echo >&2 "non-portable file name(s): $$bad"; exit 1; } | |
103 | ||
e3df89a4 JS |
104 | aggregate-results-and-cleanup: $(T) |
105 | $(MAKE) aggregate-results | |
106 | $(MAKE) clean | |
107 | ||
f8d5ffc2 | 108 | aggregate-results: |
54bb9015 | 109 | for f in '$(TEST_RESULTS_DIRECTORY_SQ)'/t*-*.counts; do \ |
6508eedf BC |
110 | echo "$$f"; \ |
111 | done | '$(SHELL_PATH_SQ)' ./aggregate-results.sh | |
f8d5ffc2 | 112 | |
958a8467 JN |
113 | gitweb-test: |
114 | $(MAKE) $(TGITWEB) | |
115 | ||
7f6fdea1 | 116 | valgrind: |
7ef4d6b9 | 117 | $(MAKE) GIT_TEST_OPTS="$(GIT_TEST_OPTS) --valgrind" |
7f6fdea1 | 118 | |
342e9ef2 TR |
119 | perf: |
120 | $(MAKE) -C perf/ all | |
121 | ||
80339445 | 122 | .PHONY: pre-clean $(T) aggregate-results clean valgrind perf check-chainlint clean-chainlint |